
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 61.20</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">ThuanNH</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="customerList.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Customer</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="orderList.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order List By Customer</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menuList.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Combo Menu</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="voucherList.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drinkList.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Order Filter</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        
        <div class = "container jumbotron">
          <div class="row">
            <label class = "col-sm-2 col-form-label">Customer Name</label>
            <div class = "col-sm-3">
                <select id="select-customer" class = "form-control">
                    <option>
                    </option>
                </select>
            </div>
            <button class="btn btn-info col-sm-2" id="btn-filter-orders">Lọc</button>
          </div>
          
        </div>
        <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>Id</th>
              <th>Order Code</th>
              <th>Kích cỡ combo</th>
              <th>Loại pizza</th>
              <th>Voucher Code</th>
              <th>Thành tiền</th>
              <th>Phải thanh toán</th>
            </tr>
        </table>
      </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<!-- <script src="dist/js/adminlte.min.js"></script> -->

<script>
  "use strict";
$(document).ready(function() {
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  
  // base url API
  const gBASE_URL = "http://localhost:8080/orders";

  var gOrdersArr =[];
  const gCOLUMN_ID = 0;
  const gCOLUMN_CODE = 1;
  const gCOLUMN_COMBO = 2;
  const gCOLUMN_PIZZA = 3;
  const gCOLUMN_VOUCHER_CODE = 4;
  const gCOLUMN_AMOUNT = 5 ;
  const gCOLUMN_PAID = 6 ;
  //const gCOLUMN_CUSTOMER = 7 ;

  const gUSER_COL = ["id","orderCode","pizzaSize","pizzaType","voucherCode","price","paid"];
  
  // khởi tạo data table  - chưa có data
  var gOrderTable = $("#order-table").DataTable( {
    // Khai báo các cột của datatable
    "columns" : [
        { "data" : gUSER_COL[gCOLUMN_ID] },
        { "data" : gUSER_COL[gCOLUMN_CODE] },
        { "data" : gUSER_COL[gCOLUMN_COMBO] },
        { "data" : gUSER_COL[gCOLUMN_PIZZA] },
        { "data" : gUSER_COL[gCOLUMN_VOUCHER_CODE] },
        { "data" : gUSER_COL[gCOLUMN_AMOUNT] },
        { "data" : gUSER_COL[gCOLUMN_PAID] },
        //{ "data" : gUSER_COL[gCOLUMN_CUSTOMER] },
    ]
  });
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  //gán sự kiện cho nút filter
  $("#btn-filter-orders").click(function(){
    onBtnFilterOrderClick();
  })

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  // hàm chạy khi trang được load
  function onPageLoading() {
    // lấy data từ server
    $.ajax({
      url: gBASE_URL,
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
        //debugger;
        gOrdersArr = responseObject;
        loadDataToTable(responseObject);
      },
      error: function(error){
        console.assert(error.responseText);
      }
    });
    //Lấy danh sách Customer khi tải trang
    getCustomerList();
  }
  
  //hàm xử lý sự kiện filter
  function onBtnFilterOrderClick(){
    var gCustomerId = $("#select-customer").val();
    // lấy data từ server
    $.ajax({
      url: "http://localhost:8080/customer-orders-query?customerId=" + gCustomerId,
      type: "GET",
      dataType: 'json',
      success: function(responseObject){
        //debugger;
        gOrdersArr = responseObject;
        loadDataToTable(responseObject);
      },
      error: function(error){
        console.assert(error.responseText);
      }
    });
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
  // load data to table
  function loadDataToTable(paramResponseObject) {
    //Xóa toàn bộ dữ liệu đang có của bảng
    gOrderTable.clear();
    //Cập nhật data cho bảng 
    gOrderTable.rows.add(paramResponseObject);
    //Cập nhật lại giao diện hiển thị bảng
    gOrderTable.draw();
  }
  //Get customerlist khi tải trang
  function getCustomerList(){
    "use strict";
    var vBASE_URL ="http://localhost:8080/customers";
    $.ajax({
      url: vBASE_URL,
      type: "GET",
      dataType: "json",
      success: function(res){
        handleCustomerList(res);
      },
      error: function(ajaxContext){
        alert(ajaxContext.responseText);
      }
    });
  }
  //hàm load option cho customer select element
  function handleCustomerList(paramCustomer){
      "use strict";
      var vArrayCustomerList = paramCustomer;
      //load data to customer select
      var vSelectCustomer = document.getElementById("select-customer");
      for (var bI = 0; bI < vArrayCustomerList.length; bI++){
        var vCustomerOption = document.createElement("option");
        vCustomerOption.value = vArrayCustomerList[bI].id;
        vCustomerOption.text =  vArrayCustomerList[bI].fullname;
        vSelectCustomer.appendChild(vCustomerOption);
      }
    }
  
});
</script>
</body>
</html>